/* Puzzle.h */

/* Definicoes para compilacao */

#define PC                               /* Seta interface para IBM PC */
#define DISTANCIA                        /* Seta a funcao heuristica para
					    levar em conta a distancia da
					    peca de sua casa. */

/* Constantes */

#define TRUE  1
#define FALSE 0

/* Transformacoes */

#define ORD(X) (X - 48)                  /* Transforma ASCII para numerico */
#define CHR(X) (X + 48)                  /* Transforma de numerico p/ ASCII */

#define FIXE_G(X,Y) (X->g = Y)           /* Fixa o valor de g */
#define FIXE_H(X,Y) (X->h = Y)           /* Fixa o valor de h */
#define G(X)        (X->g)               /* Retorna o valor de g no nodo */
#define H(X)        (X->h)               /* Retorna o valor de h no nodo */
#define F(X)        (X->g + X->h)        /* Retorna o valor de f no nodo */

#define TABULEIRO(X) (X->tabuleiro)      /* Referencia o tabuleiro do nodo */

#define TABULEIROS_IGUAIS(X,Y) (X->tabuleiro == Y->tabuleiro)
					 /* Compara dois tabuleiros, retorna
					    verdadeiro se sao iguais ou falso
					    caso contrario */

#define APONTAR(X,Y) (X->melhor_no = Y)  /* Secessor aponta para melhor no */

#define MAXSUCESSORES  4

/* Tipos */

typedef unsigned char byte;
typedef unsigned int  word;

typedef struct no {

  long tabuleiro;               /* Descricao do esdado de problema */

  word g,                       /* Custo de ir do estado inicial ao atual */
       h;                       /* Custo de ir do estado atual a solucao */

  struct no huge *melhor_no,    /* Mostra o melhor no de onde ele veio */
	    huge *proximo_fila; /* Possibilita a implementacao de filas dos
				   nodos abertos e fechados. */

  struct no huge *sucessores [MAXSUCESSORES], /* Sucessores deste no */

	    huge *proximo_no;   /* Lista para a desalocacao de todos os nos
				   gerados */

} huge*no;

/* Prototipos das funcoes */

word calcule_h (no);
byte posicao (long, byte, byte);
void setar_posicao (no, byte, byte, byte);
void zera_sucessores (no []);
void inicialize (no);
no acha_melhor_no (no *);
void cria_sucessor (byte, byte, byte, byte, no, no);
byte gera_sucessores (no [], no);
void atualiza_nivel_arvore (no);
byte esta_em (no, no, no*);
void acrescenta_sucessor (no, no);
void expanda_f (no, byte);
